import java.util.*;
String[] months = {
  "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
}; 
ArrayList transactions = null; //global List of the data
HashMap hm = new HashMap(); 

int radius = 100;
int maxValue = 112000;
int minValue = 0;
int WIDTH = 1280; 
int HEIGHT = 720; 

float offsetX=WIDTH*.5; 
float offsetY=HEIGHT*.5;
boolean rotation = false; 

int currentMonth = 1; 
Integrator[] interpolators;

String[] s;

void setup()
{
  noStroke();
  size(1280,720); 
  smooth(); 
  background(255); 

  /*s = {"Audio Tape - Juv", "Audio Tape - Adult", "CD - Adult", "CD - Juv", "Other - Adult", "VHS - Adult 1",
  "Book - Juv", "Diskette - Adult", "Microfilm - Adult","VHS - Juv", "Uncataloged", "Book - Adult", "Book - Ref Juv",
  "VHS - Juv Multi Vol", "CD-ROM - Ref Adult", "Slides - Adult", "CD-ROM - Adult", "Book - Adult 2", "Poster - Adult",
  "Magazine - Adult", "Song Book - Ref Juv", "Book - Ref Adult", "VHS - Adult", "Book on CD - Adult", "CD-ROM - Juv",
  "DVD - Juv Circulating", "DVD - Adult", "Kit - Adult", "Music Score - Adult", "VHS - Adult 2", "Kit - Juv" 
  };
  s = sort(s);*/

  this.transactions = loadTransactions();
  textAlign(LEFT,CENTER); 
  frameRate(60);  
  colorMode(HSB,360); 

  interpolators = new Integrator[33];
  for (int row = 0; row < 33; row++) {
    interpolators[row] = new Integrator(0);
    interpolators[row].attraction = .9;
    interpolators[row].damping = .60;
  }
  //println(Collecions.sort);
  calculateDeweys(currentMonth);
 
  
  /*Object[] tmp = hm.keySet().toArray();
  Arrays.sort(tmp);
  
  HashMap tmpHm = new HashMap();
  
  for(int i=0; i<tmp.length; i++){
    Iterator j = hm.entrySet().iterator();  // Get an iterator
    while(j.hasNext()){
      Map.Entry me = (Map.Entry)j.next();
      String itemType = (String) me.getKey();
      if(tmp[i].equals(itemType)){
        tmpHm.put(itemType,me.getValue());
      }
    }
  }
  
  hm = tmpHm;*/
  /*Iterator i = hm.entrySet().iterator();  // Get an iterator

  while (i.hasNext()) {
    
  }*/
}

void draw()
{
  background(200); 

  if(mousePressed == true)
  {
    offsetX = mouseX; 
    offsetY = mouseY;
  }  
  fill(80);
  textSize(20);
  text(months[currentMonth-1],40,40);
  textSize(25);
  text("2009",40,65);
  fill(340);
  textSize(12);
  text("Amount of Item Types referenced under",40,100);
  textSize(28);
  text("Arts and Recreation",40,122);
  fill(80);
  textSize(12);
  text("Skip to the next month by pressing the 'n' key",40,650);
  text("Skip to the previous month by pressing the 'p' key",40,665);
  text("Press the mouse button to drag and drop the graph",40,680);
  translate(offsetX, offsetY); 
  rotate(((float)mouseX/width)*TWO_PI);
  float angle = 0;
  textAlign(CENTER,CENTER); 
  textAlign(LEFT,CENTER); 

  for(int i=0; i < hm.size(); i++) {
    interpolators[i].update();
  }

  int counter = 0; 

  Iterator i = hm.entrySet().iterator();  // Get an iterator

    while (i.hasNext()) {

    Map.Entry me = (Map.Entry)i.next();
    //println(Map.Entry);
    //println(me.getValue());
        /*String[] s = { 
      Map.Entry me
    };
    s = sort(s);
    println(hm.entrySet().iterator());*/

    float theta = radians(counter*360.0/hm.size());
    float x = cos(theta)*radius;
    float y = sin(theta)*radius;
    float nbrUmpr = (float)interpolators[counter].value; 
    pushMatrix();
    translate(x,y);
    rotate(theta);  
    nbrUmpr = map(nbrUmpr, 0, maxValue, 20, 300);
    float diffInOut = 15;
    float x1 = 0;
    float y1 = (diffInOut/4)*-1;
    float x2 = 0;
    float y2 = diffInOut/4;
    float x4 = nbrUmpr;
    float y4 = (diffInOut/2)*-1;
    float x3 = nbrUmpr;
    float y3 = diffInOut/2;
    String itemType = (String) me.getKey();
    String tmp = checkItemType(itemType);

    //println(itemType);


    if(!tmp.equals("NULL")) {
      fill(getColor(tmp));
      quad(x1,y1,x2,y2,x3,y3,x4,y4);
      textSize(18);
      text(tmp,x4+5,-3);
    }
    popMatrix(); 

    angle+=10.909; 
    counter++;
  }
}
color getColor(String t) {
  if(t.equals("Audio Tape - Juv")) {
    return color(320,360,360);
  }
  else if(t.equals("Audio Tape - Adult")) {
    return color(320,150,150);
  }
  else if(t.equals("CD - Adult")) {
    return color(260,150,150);
  }
  else if(t.equals("CD - Juv")) {
    return color(260,360,360);
  }
  else if(t.equals("Other - Adult")) {
    return color(0,0,150);
  }
  else if(t.equals("VHS - Adult")) {
    return color(0,150,150);
  }
  else if(t.equals("Book - Juv")) {
    return color(300,360,360);
  }
  else if(t.equals("Diskette - Adult")) {
    return color(220,150,150);
  }
  else if(t.equals("Microfilm - Adult")) {
    return color(140,150,150);
  }
  else if(t.equals("VHS - Juv")) {
    return color(0,360,360);
  }
  else if(t.equals("Uncataloged")) {
    return color(0,0,250);
  }
  else if(t.equals("Book - Adult")) {
    return color(300,150,150);
  }
  else if(t.equals("Book - Ref Juv")) {
    return color(300,300,300);
  }
  else if(t.equals("VHS - Juv Multi Vol")) {
    return color(0,300,300);
  }
  else if(t.equals("CD-ROM - Ref Adult")) {
    return color(240,150,150);
  }
  else if(t.equals("Slides - Adult")) {
    return color(60,150,150);
  }
  else if(t.equals("CD-ROM - Adult")) {
    return color(240,150,150);
  }
  else if(t.equals("Book - Adult 2")) {
    return color(300,165,165);
  }
  else if(t.equals("Poster - Adult")) {
    return color(80,150,150);
  }
  else if(t.equals("Magazine - Adult")) {
    return color(160,150,150);
  }
  else if(t.equals("Song Book - Ref Juv")) {
    return color(40,360,360);
  }
  else if(t.equals("Book - Ref Adult")) {
    return color(300,180,180);
  }
  else if(t.equals("VHS - Adult 1")) {
    return color(0,165,165);
  }
  else if(t.equals("Book on CD - Adult")) {
    return color(280,150,150);
  }
  else if(t.equals("CD-ROM - Juv")) {
    return color(240,360,360);
  }
  else if(t.equals("DVD - Juv Circulating")) {
    return color(200,360,360);
  }
  else if(t.equals("DVD - Adult")) {
    return color(200,150,150);
  }
  else if(t.equals("Kit - Adult")) {
    return color(180,150,150);
  }
  else if(t.equals("Music Score - Adult")) {
    return color(120,150,150);
  }
  else if(t.equals("VHS - Adult 2")) {
    return color(8,180,180);
  }
  else if(t.equals("Music Score - Ref Adult")) {
    return color(125,165,165);
  }
  else if(t.equals("Kit - Juv")) {
    return color(180,360,360);
  }
  return color(255,255,255);
}


//Convert itemtype into general type
String checkItemType(String def) {
  if(def.equals("jccas")) {
    return "Audio Tape - Juv";
  }
  if(def.equals("accas")) {
    return "Audio Tape - Adult";
  }
  if(def.equals("accd")) {
    return "CD - Adult";
  }
  if(def.equals("jccd")) {
    return "CD - Juv";
  }
  if(def.equals("acunkn")) {
    return "Other - Adult";
  }
  if(def.equals("acvhs")) {
    return "VHS - Adult 1";
  }
  if(def.equals("jcbk")) {
    return "Book - Juv";
  }
  if(def.equals("acdisk")) {
    return "Diskette - Adult";
  }
  if(def.equals("armfm")) {
    return "Microfilm - Adult";
  }
  if(def.equals("jcvhs")) {
    return "VHS - Juv";
  }  
  if(def.equals("ucunkn")) {
    return "Uncataloged";
  }
  if(def.equals("acbk")) {
    return "Book - Adult";
  }
  if(def.equals("jrbk")) {
    return "Book - Ref Juv";
  }
  if(def.equals("jlvhs")) {
    return "VHS - Juv Multi Vol";
  }
  if(def.equals("arcdrom")) {
    return "CD-ROM - Ref Adult";
  }
  if(def.equals("acslide")) {
    return "Slides - Adult";
  }
  if(def.equals("accdrom")) {
    return "CD-ROM - Adult";
  }
  if(def.equals("bcbk")) {
    return "Book - Adult 2";
  }
  if(def.equals("acpost")) {
    return "Poster - Adult";
  }
  if(def.equals("acper")) {
    return "Magazine - Adult";
  }
  if(def.equals("jcmus")) {
    return "Song Book - Ref Juv";
  }
  if(def.equals("arbk")) {
    return "Book - Ref Adult";
  }
  if(def.equals("bcvhs")) {
    return "VHS - Adult";
  }
  if(def.equals("bccd")) {
    return "Book on CD - Adult";
  }
  if(def.equals("jccdrom")) {
    return "CD-ROM - Juv";
  }
  if(def.equals("jcdvd")) {
    return "DVD - Juv Circulating";
  }
  if(def.equals("acdvd")) {
    return "DVD - Adult";
  }
  if(def.equals("ackit")) {
    return "Kit - Adult";
  }
  if(def.equals("acmus")) {
    return "Music Score - Adult";
  }
  if(def.equals("alvhs")) {
    return "VHS - Adult 2";
  }
  if(def.equals("armus")) {
    return "Music Score - Ref Adult";
  }
  if(def.equals("jckit")) {
    return "Kit - Juv";
  }
  return "Kit - Adult";
}

/*
color getColor(String t){
 
 if(t.equals("Audio Tape")){
 return color(#8fbdec);
 }
 else if(t.equals("Book")){
 return color(#6bbceb);
 }
 
 return color(255,255,255);
 
 if(def.equals("accas") || def.equals("arcas") || def.equals("bccas") || def.equals("jccas") || def.equals("jrcas")) {
 return "Audio Tape";
 }
 else if(def.equals("acbk") || def.equals("arbk") || def.equals("bcbk") || def.equals("drbk") || def.equals("jcbk") || def.equals("jrbk")) {
 return "Book";
 }
 */
